from typing import Any

WDT_RESET: int
PWRON_RESET: int

def dht_readinto(*args, **kwargs) -> Any: ...
def enable_irq(*args, **kwargs) -> Any: ...
def disable_irq(*args, **kwargs) -> Any: ...
def bitstream(*args, **kwargs) -> Any: ...
def deepsleep(*args, **kwargs) -> Any: ...
def bootloader(*args, **kwargs) -> Any: ...
def soft_reset(*args, **kwargs) -> Any: ...
def reset(*args, **kwargs) -> Any: ...
def freq(*args, **kwargs) -> Any: ...
def reset_cause(*args, **kwargs) -> Any: ...
def idle(*args, **kwargs) -> Any: ...
def time_pulse_us(*args, **kwargs) -> Any: ...
def lightsleep(*args, **kwargs) -> Any: ...
def unique_id(*args, **kwargs) -> Any: ...

class WDT:
    def feed(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

mem8: Any
mem32: Any
mem16: Any

class PWM:
    def freq(self, *args, **kwargs) -> Any: ...
    def duty_u16(self, *args, **kwargs) -> Any: ...
    def duty_ns(self, *args, **kwargs) -> Any: ...
    def deinit(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class ADC:
    CORE_TEMP: int
    def read_u16(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class I2C:
    def readfrom_mem_into(self, *args, **kwargs) -> Any: ...
    def readfrom_into(self, *args, **kwargs) -> Any: ...
    def readfrom_mem(self, *args, **kwargs) -> Any: ...
    def writeto_mem(self, *args, **kwargs) -> Any: ...
    def scan(self, *args, **kwargs) -> Any: ...
    def writeto(self, *args, **kwargs) -> Any: ...
    def writevto(self, *args, **kwargs) -> Any: ...
    def start(self, *args, **kwargs) -> Any: ...
    def readfrom(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def stop(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class I2S:
    RX: int
    MONO: int
    STEREO: int
    TX: int
    def shift(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def irq(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def deinit(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class Pin:
    ALT_SPI: int
    IN: int
    ALT_USB: int
    ALT_UART: int
    IRQ_FALLING: int
    OUT: int
    OPEN_DRAIN: int
    IRQ_RISING: int
    PULL_DOWN: int
    ALT_SIO: int
    ALT_GPCK: int
    ALT: int
    PULL_UP: int
    ALT_I2C: int
    ALT_PWM: int
    ALT_PIO1: int
    ALT_PIO0: int
    def low(self, *args, **kwargs) -> Any: ...
    def irq(self, *args, **kwargs) -> Any: ...
    def toggle(self, *args, **kwargs) -> Any: ...
    def off(self, *args, **kwargs) -> Any: ...
    def on(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def value(self, *args, **kwargs) -> Any: ...
    def high(self, *args, **kwargs) -> Any: ...

    class cpu:
        GPIO20: Any
        GPIO25: Any
        GPIO26: Any
        GPIO27: Any
        GPIO24: Any
        GPIO21: Any
        GPIO22: Any
        GPIO23: Any
        GPIO28: Any
        GPIO6: Any
        GPIO7: Any
        GPIO8: Any
        GPIO5: Any
        GPIO29: Any
        GPIO3: Any
        GPIO4: Any
        GPIO9: Any
        GPIO2: Any
        GPIO1: Any
        GPIO10: Any
        GPIO11: Any
        GPIO0: Any
        EXT_GPIO0: Any
        EXT_GPIO1: Any
        EXT_GPIO2: Any
        GPIO12: Any
        GPIO17: Any
        GPIO18: Any
        GPIO19: Any
        GPIO16: Any
        GPIO13: Any
        GPIO14: Any
        GPIO15: Any
        def __init__(self, *argv, **kwargs) -> None: ...

    class board:
        GP3: Any
        GP28: Any
        GP4: Any
        GP5: Any
        GP22: Any
        GP27: Any
        GP26: Any
        WL_GPIO2: Any
        WL_GPIO0: Any
        LED: Any
        WL_GPIO1: Any
        GP6: Any
        GP7: Any
        GP9: Any
        GP8: Any
        GP12: Any
        GP11: Any
        GP13: Any
        GP14: Any
        GP0: Any
        GP10: Any
        GP1: Any
        GP21: Any
        GP2: Any
        GP19: Any
        GP20: Any
        GP15: Any
        GP16: Any
        GP18: Any
        GP17: Any
        def __init__(self, *argv, **kwargs) -> None: ...

    def __init__(self, *argv, **kwargs) -> None: ...

class SoftSPI:
    LSB: int
    MSB: int
    def deinit(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def write_readinto(self, *args, **kwargs) -> Any: ...
    def read(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class Timer:
    PERIODIC: int
    ONE_SHOT: int
    def init(self, *args, **kwargs) -> Any: ...
    def deinit(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class UART:
    INV_TX: int
    RTS: int
    CTS: int
    INV_RX: int
    def deinit(self, *args, **kwargs) -> Any: ...
    def sendbreak(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def flush(self, *args, **kwargs) -> Any: ...
    def txdone(self, *args, **kwargs) -> Any: ...
    def read(self, *args, **kwargs) -> Any: ...
    def any(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def readline(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class SoftI2C:
    def readfrom_mem_into(self, *args, **kwargs) -> Any: ...
    def readfrom_into(self, *args, **kwargs) -> Any: ...
    def readfrom_mem(self, *args, **kwargs) -> Any: ...
    def writeto_mem(self, *args, **kwargs) -> Any: ...
    def scan(self, *args, **kwargs) -> Any: ...
    def writeto(self, *args, **kwargs) -> Any: ...
    def writevto(self, *args, **kwargs) -> Any: ...
    def start(self, *args, **kwargs) -> Any: ...
    def readfrom(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def stop(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class RTC:
    def datetime(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class SPI:
    LSB: int
    MSB: int
    def deinit(self, *args, **kwargs) -> Any: ...
    def init(self, *args, **kwargs) -> Any: ...
    def write_readinto(self, *args, **kwargs) -> Any: ...
    def read(self, *args, **kwargs) -> Any: ...
    def write(self, *args, **kwargs) -> Any: ...
    def readinto(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...

class Signal:
    def off(self, *args, **kwargs) -> Any: ...
    def on(self, *args, **kwargs) -> Any: ...
    def value(self, *args, **kwargs) -> Any: ...
    def __init__(self, *argv, **kwargs) -> None: ...
